using System;
using System.IO;
using System.Diagnostics;
using System.Threading;

 
namespace OrangejuiceElectronica {
	public class UrlToNix {
		public static string sFile="";
		public static string sFileOutput=System.Environment.GetFolderPath(System.Environment.SpecialFolder.Personal)+"/lib/urltonix/1.Output.txt";
		public static int iOutputs=0;
		public static bool bGood=false;
		public static int iFoundFiles=0;
		public static int iFoundUrls=0;
		public static string sLine="";
		public static string sLastComment="";
		public static string sMiniName="urltonix";
		public static string sMyName="UrlToNix";
		public static string sVersion="1.0-20070803";
		public static readonly string[] sarrAllowedLinks=new string[]{"htm","php","asp"};
		public static int iDone=0;
		public static string sMyNameFull {
			get {
				return sMyName+" "+sVersion;
			}
		}
		public static void Main(string[] sarrArg) {
			string sVerb="starting";
			StreamReader srNow=null;
			WriteLine("(debug output file is \""+sFileOutput+"\")");
			try {
				int iArg=0;
				foreach (string sFile in sarrArg) {
					sVerb="p argument "+sFile;
					if ((!(sFile=="mono"&&iArg==0)) && (!(sFile=="mono"&&iArg==0)) && (sFile!=sMiniName) && (sFile!=sMiniName+".exe") && File.Exists(sFile)) {
						iFoundFiles++;
						sVerb="opening file "+sFile;
						srNow=File.OpenText(sFile);
						int iLine=1;
						while (( sLine = srNow.ReadLine() ) != null ) {
							try {
								sVerb="processing line \""+sLine+"\"";
								while (sLine.StartsWith(" ")||sLine.StartsWith("\t")) sLine=sLine.Length>1?sLine.Substring(1):"";
								while (sLine.EndsWith(" ")||sLine.EndsWith("\t")) sLine=sLine.Length>1?sLine.Substring(0,sLine.Length-1):"";
								if (sLine.StartsWith("[")&&sLine.EndsWith("]")) {
									sVerb="processing comment"+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
									sLastComment="sLine";
								}
								else if (sLine!="") {// && !sLine.StartsWith("#")) {
									sVerb="processing non-blank line"+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
									int iSign=sLine.IndexOf("=");
									string sHref="href=\"";
									int iHref=sLine.IndexOf(sHref);
									int iHrefCloser=-1;
									if (iHref>=0) iHrefCloser=sLine.Substring(iHref+sHref.Length).IndexOf("\"")+(iHref+sHref.Length);
									string sCommand = "";
									int iUrl=sLine.IndexOf("http://");
									if (sLine.StartsWith("http://")) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which starts with \"http://\": \""+sLine+"\"";
										int iSpace=sLine.IndexOf(" ");
										sCommand=(iSpace>0)?sLine.Substring(0,iSpace):sLine;
									}
									else if (iHref>=0&&iHrefCloser>iHref) {//if (!sLine.StartsWith("http://")) {
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an href statement: \""+sLine+"\"";
											iHref+=sHref.Length;
											sCommand=sLine.Substring(iHref,iHrefCloser-iHref);
											if (!HasAllowedLink(sCommand)) {
												sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unusable href statement: \""+sLine+"\"";
												sCommand="";
											}
											else {
												sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has a usable href statement: \""+sLine+"\"";
											}
									}
									else if (sLine.ToUpper().StartsWith("URL=")) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has a standard URL= statement: \""+sLine+"\"";
										sCommand=((iSign+1<sLine.Length)?sLine.Substring(iSign+1):"");
									}
									else if (iUrl>=0) {
										sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at index "+iUrl.ToString()+": \""+sLine+"\"";
										int iEnder=sLine.Substring(iUrl).IndexOf(" ")+iUrl;
										if (iEnder>iUrl) {
											string sTemp=sLine.Substring(0,iUrl)+"["+sMiniName+"-found-url-here-to-end-of-line]"+sLine.Substring(iUrl);
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at character [index+1=]"+(iUrl+1).ToString()+" ending before ["+iEnder.ToString()+"]: \""+sTemp+"\"";
											sCommand=sLine.Substring(iUrl,iEnder-iUrl);
										}
										else {
											string sTemp=sLine.Substring(0,iUrl)+"["+sMiniName+"-found-url-here-to-end-of-line]"+sLine.Substring(iUrl);
											sVerb="processing line "+iLine.ToString()+" of "+sFile+" which has an unmarked link at index [index+1=] "+(iUrl+1).ToString()+": \""+sTemp+"\"";
											sCommand=sLine.Substring(iUrl);
										}
									}
									if (sCommand!="") {
										sVerb="processing command \""+sCommand+"\" on line "+iLine.ToString()+" of "+sFile+": \""+sLine+"\"";
										iFoundUrls++;
										System.Diagnostics.Process proc = new System.Diagnostics.Process();
										proc.EnableRaisingEvents=false;
										//if (iSpace>-1) {
										//	sCommand=sLine.Substring(0,iSpace);
										//	sArgs=sLine.Substring(iSpace+1);
											proc.StartInfo.FileName=sCommand;
										//	proc.StartInfo.Arguments=sArgs;
										//}
										//else {
										//	proc.StartInfo.FileName=sLine;
										//}
										try {
											if (iDone==1||iDone==0) { //==0 to prevent errors when program was just called but firefox isn't finished loading
												WriteLine();
												WriteLine("   Waiting for browser (prevents \"Firefox is already open\" errors)...");
												WriteLine();
												Thread.Sleep(7000); //allows browser to load before dumping more stuff into it and confusing it (i.e. prevents "firefox already running" errors)
											}
											iFoundUrls++;
											WriteLine("   Telling computer to run: \""+sCommand+"\"");
											proc.Start();
											iDone++;
										}
										catch (Exception exn) {
											WriteLine("   OS could not execute \""+sCommand+"\"");
											WriteLine("      "+exn.ToString());
										}
										//proc.WaitForExit();
									}//end if sCommand!=""
									else WriteLine("   NO URL in "+sFile+" LINE "+iLine.ToString());//+": "+sLine);
								}//end if not blank
							}
							catch (Exception exn) {
								WriteLine("   Exception error while "+sVerb+".");
								WriteLine();
								WriteLine("   "+exn.ToString());
							}
							iLine++;
						}//end while ReadLine
						srNow.Close();
						if (iFoundUrls<=0) WriteLine("   No lines were found except "+((sLastComment!="")?("comments (i.e. "+sLastComment+")"):"blanks")+" in "+sFile);
					}//end if parameter in sarrArg is not the program itself
					//else {
						//WriteLine("The file was not found, so nothing was done.");
					//}
					iArg++;
				}//end foreach sFile in sarrArg
				if (iFoundFiles<=0) {
					WriteLine();
					WriteLine("   Welcome to "+sMyName);
					WriteLine();
					WriteLine();
					WriteLine("   To use this program, type");
					WriteLine();
					WriteLine("      mono "+sMiniName+".exe filename.url");
					WriteLine();
					WriteLine("   where filename.url is the URL file that you want to execute");
					WriteLine();
					WriteLine("   OR");
					WriteLine();
					WriteLine("   create a \"File Association\" (i.e. in \"Settings\", \"Configure Konqueror\" in KDE browser)");
					WriteLine("   for *.URL and *.url file masks and use \"mono ./"+sMiniName+".exe\"");
					WriteLine("   as the preferred application where '.' is the directory");
					WriteLine("   where "+sMiniName+".exe is located.");
					WriteLine();
					WriteLine("   TROUBLESHOOTING: after making the file association, make sure that");
					WriteLine("   the full command for the preferred application is used");
					WriteLine("   as of Konqueror 3.5.6-0.1.fc6, Konqueror reverts to using \"mono\",");
					WriteLine("   so after setting the association you have to go back and re-add");
					WriteLine("   the path to "+sMiniName+".exe after \"mono\" as shown above.");
					WriteLine();
					WriteLine("                     http://www.expertmultimedia.com/orangejuice/");
					WriteLine();
				}
				bGood=iFoundUrls>0;
			}
			catch (Exception exn) {
				WriteLine("   Exception error while "+sVerb+".");
				WriteLine();
				WriteLine("   "+exn.ToString());
			}
			//if (!bGood) WriteLine("Finished unsuccessfully...");
			//WriteLine("(Finished "+iCount.ToString()+" commands)");
			WriteLine();
			WriteLine("   Program Finished "+(bGood?"(Success)":"(nothing done)"));
			//Console.ReadLine();
			WriteLine();
		}
		public static bool HasAllowedLink(string sUrl) {
			bool bFound=false;
			int iMinLoc=2; //i.e. allows 1.htm but not xhtm
			if (sUrl!=null && sUrl!="") {
				foreach (string sNow in sarrAllowedLinks) {
					if (sUrl.IndexOf(sNow)>=iMinLoc) {
						bFound=true;
						break;
					}
				}
			}
			return bFound;
		}
		public static bool bCreatedOutput=false;
		public static void Write(string sMsg) {
			StreamWriter swNow;
			try {
				StringToConsole(sMsg);
				if (sMsg.IndexOf(Environment.NewLine)>=0) iOutputs++;
				//iOutputs++;
				//if (iOutputs<iMaxOutputs) {
					swNow=File.AppendText(sFileOutput);
					swNow.Write(sMsg);
					swNow.Close();
				//}
				//else if (iOutputs==iMaxOutputs) {
				//	swNow=File.AppendText(sFileOutput);
				//	swNow.Write(Marker+"MAXIMUM MESSAGES REACHED--This is the last message that will be shown: "+sMsg);
				//	swNow.Close();
				//}
			}
			catch {//(Exception exn) {
				try {
					//IgnoreExn(exn,"Write","trying to append output text file");
					if (!bCreatedOutput) {
						swNow=File.CreateText(sFileOutput);
						swNow.Write(sMsg);
						swNow.Close();
					}
					bCreatedOutput=true;
				}
				catch {
					//IgnoreExn(exn2,"Write","trying to create new output text file");//ignore since "error error"
				}
			}
		}//end Write
		public static void WriteLine(string sMsg) {
			Write(sMsg+Environment.NewLine);
		}
		public static void WriteLine() {
			Write(Environment.NewLine);
		}
		public static void StringToConsole(string sMsg) {
			int iNow=0;
			string sCumulative="";
			if (sMsg!=null) {
				while (iNow<sMsg.Length) {
					if (CompareAt(sMsg,Environment.NewLine,iNow)) {
						Console.WriteLine(sCumulative);
						iNow+=Environment.NewLine.Length;
						sCumulative="";
					}
					else {
						sCumulative+=char.ToString(sMsg[iNow]);
						iNow++;
					}
				}
				if (sCumulative!="") Console.Write(sCumulative);
			}
		}
		public static bool CompareAt(string sHaystack, string sNeedle, int iAtHaystack) {
			int iMatches=0;
			int iNeedle=0;
			if (sHaystack!=null&&sHaystack!=""&&sNeedle!=null&&sNeedle!="") {
				iNeedle=sNeedle.Length;
				for (int iNow=0; iNow<iNeedle; iNow++) {
					if (sHaystack[iAtHaystack]==sNeedle[iNow]) iMatches++;
					iAtHaystack++;
				}
			}
			return iMatches!=0&&iMatches==iNeedle;
		}
	}//end UrlToNix
}//end namespace
